require 'rails_helper'

module Mks
  module Rent
    RSpec.describe OfferItem, type: :model do
      it 'has a valid factory' do
        expect(create(:offer_item)).to be_valid
      end

      it 'is invalid without from' do
        expect(build(:offer_item, from: nil)).not_to be_valid
      end

      it 'is invalid without to' do
        expect(build(:offer_item, to: nil)).not_to be_valid
      end

      it 'is invalid without unit_price' do
        expect(build(:offer_item, unit_price: nil)).not_to be_valid
      end

      it 'is invalid with from greater than to' do
        expect(build(:offer_item, from: Date.today, to: Date.today - 10)).not_to be_valid
      end
    end
  end
end