require 'rails_helper'

module Mks
  module Rent
    RSpec.describe OfferRequest, type: :model do
      it 'has a valid factory' do
        expect(create(:offer_request)).to be_valid
      end

      it 'is invalid with no client' do
        expect(build(:offer_request, client: nil)).not_to be_valid
      end

      it 'is invalid with no status' do
        expect(build(:offer_request, status: nil)).not_to be_valid
      end

      it 'is invalid with random status value' do
        expect(build(:offer_request, status: 'SOME STATUS')).not_to be_valid
      end
    end
  end
end
