require 'rails_helper'

module Mks
  module Rent
    RSpec.describe Offer, type: :model do
      it 'has a valid factory' do
        expect(create(:offer)).to be_valid
      end

      it 'is invalid without confirmed value' do
        expect(build(:offer, confirmed: nil)).not_to be_valid
      end

      it 'is invalid without booked value' do
        expect(build(:offer, booked: nil)).not_to be_valid
      end
    end
  end
end