require 'rails_helper'

module Mks
  module Rent
    RSpec.describe RequestItem, type: :model do
      it 'has a valid factory' do
        expect(create(:request_item)).to be_valid
      end

      it 'is invalid with no service bundle' do
        expect(build(:request_item, service_bundle: nil)).not_to be_valid
      end

      it 'is invalid with no from' do
        expect(build(:request_item, from: nil)).not_to be_valid
      end

      it 'is invalid with no to' do
        expect(build(:request_item, to: nil)).not_to be_valid
      end

      it 'is invalid with no quantity' do
        expect(build(:request_item, quantity: nil)).not_to be_valid
      end

      it 'is invalid with from greater than to' do
        expect(build(:request_item, from: Date.today, to: Date.today - 10)).not_to be_valid
      end
    end
  end
end